package org.jk.rag.service;

import org.jk.common.mybatis.core.page.TableDataInfo;
import org.jk.common.mybatis.core.page.PageQuery;
import org.jk.rag.domain.bo.SysUserOnlineLogBo;
import org.jk.rag.domain.dto.ConversationReqDTO;
import org.jk.rag.domain.dto.OverviewAppDTO;
import org.jk.rag.domain.dto.OverviewAppDetailDTO;
import org.jk.rag.domain.dto.OverviewKnowledgeDTO;
import org.jk.rag.domain.vo.SysUserOnlineLogVo;

import java.util.Collection;
import java.util.List;

/**
 * 在线人数记录Service接口
 *
 * @author Lion Li
 * @date 2026-01-22
 */
public interface ISysUserOnlineLogService {

    /**
     * 查询在线人数记录
     *
     * @param id 主键
     * @return 在线人数记录
     */
    SysUserOnlineLogVo queryById(Long id);

    /**
     * 分页查询在线人数记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 在线人数记录分页列表
     */
    TableDataInfo<SysUserOnlineLogVo> queryPageList(SysUserOnlineLogBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的在线人数记录列表
     *
     * @param bo 查询条件
     * @return 在线人数记录列表
     */
    List<SysUserOnlineLogVo> queryList(SysUserOnlineLogBo bo);

    /**
     * 新增在线人数记录
     *
     * @param bo 在线人数记录
     * @return 是否新增成功
     */
    Boolean insertByBo(SysUserOnlineLogBo bo);

    /**
     * 修改在线人数记录
     *
     * @param bo 在线人数记录
     * @return 是否修改成功
     */
    Boolean updateByBo(SysUserOnlineLogBo bo);

    /**
     * 校验并批量删除在线人数记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    List<SysUserOnlineLogVo> queryThirtyDayData();

    List<SysUserOnlineLogVo> queryTwelveMonthData();

    List<ConversationReqDTO> queryThirtyDayConversationData();

    List<ConversationReqDTO> queryTwelveMonthConversationData();

    List<ConversationReqDTO> queryThirtyDayConversationDetailData();

    List<ConversationReqDTO> queryTwelveMonthConversationDetailData();

    List<OverviewAppDTO> queryOverviewAppData();

    TableDataInfo<OverviewAppDetailDTO> queryOverviewAppDetailData(PageQuery pageQuery);

    TableDataInfo<OverviewKnowledgeDTO> queryOverviewKnowledgeData(PageQuery pageQuery);


}
